<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Title</title>
</head>
<body>
<h1>Using constraints & “magic numbers” to build responsive layouts in Figma</h1>
<div>
    <figure>
        <img src="https://miro.medium.com/max/875/1*Y2dJzfk5qWf-vI1MYiiTVw.png">
        <figcaption>Image created for Figma by Peter Barnaba</figcaption>
    </figure>
</div>
<em>This post is part of a series: <a
        href="https://medium.com/@littlebits.product/building-a-design-system-with-figma-at-littlebits-17edff8f4236">a
    design system with Figma at littleBits.</a> Read the previous post — how we
    created atomic components with Figma — <a
            href="https://www.figma.com/blog/creating-responsive-layout-templates-in-figma/">here.</a></em>
<p>This year we faced a big challenge at Little Bits — launching 4 new apps on multiple platforms with both mobile and
    tablet layouts. We knew we needed a strong design system to do it right, particularly given our small team and short
    time span (6 months).</p>
<p>Templates with responsive layouts played a key role in scaling our work. Here’s how we figured out the approach that
    worked for us in both Figma and React.</p>
<section>
    <h2>Magic Number</h2>
    <mark>One thing that’s great to have at the heart of a design system is a ‘magic number’ — it helps harmonize layout
        if
        sizes of text, graphic elements, margins, and padding, share a common numeric factor.
    </mark>
    <p>Before we had any kind of system, we had mocks of several key screens that had been created to establish the
        visual
        direction of the app.</p>
    <div>
        <figure>
            <img src="https://miro.medium.com/max/1400/1*TqFz6lS9kuTmok-clI-X1Q.png">
            <figcaption>Initial ‘eyeballed’ design mock compared with eventual design using layout based off 8's
            </figcaption>
        </figure>
    </div>
    <p>We looked at the sizes and padding that had been ‘eyeballed’ in these designs, and found that things were mostly
        working off 8’s — buttons were 48px high, margins were mostly 24px, some headings were 32px, etc.</p>
    <p>Everything was close enough to nudge towards numbers that multiplied from 8 (and 8 in itself is a number that
        multiplies and divides well!). So 8 became our magic number for all things moving forward.</p>
    <div>
        <figure>
            <img src="https://miro.medium.com/max/1400/1*kmKS2fqTI7jtkDDdwm_VjQ.png">
            <figcaption>Buttons built on a scale of 8</figcaption>
        </figure>
    </div>
    <p>From smallest to largest our buttons and form elements were made 32, 48, 56, 64, & 96px high; key headings & copy
        48,
        32, 24, & 16px; padding & gutters 16, 24, & 32px; larger layout cards would be 240px high.</p>
    <p>You get the picture…all the key sizes are multiples of 8!</p>
</section>
<section>
    <h2>Different Screen Sizes</h2>
    <p>Figma is great for building with responsive constraints — you can stretch your layouts and see how they will
        respond
        to changes in screen size. (If you’re new to constraints in Figma, check out <a
                href="https://medium.com/figma-design/http://8%20became%20our%20magic%20number%20for%20all%20things%20moving%20forward.">beginner
            primer here.)</a></p>
    <p>You can even have elements pin to edges of a column:</p>
    <div>
        <figure>
            <img src="https://miro.medium.com/max/1400/1*dFGDlSVyHIKEtHyrcMGxHA.gif">
            <figcaption>Pin elements to a column in Figma using constraints</figcaption>
        </figure>
    </div>
    <p>But it’s hard to create a single layout that will look good on most phones, still fit on a smaller phone like an
        iPhone SE, and feel full on a tablet.</p>
    <div>
        <figure>
            <img src="https://miro.medium.com/max/1400/1*-tgO36tfC_joP2YCHuKZhA.png">
            <figcaption>Controls layouts on different screens with nothing but layout constraints.</figcaption>
        </figure>
    </div>
    <p>Around half our users are loading the app on a tablet, so we didn’t want the experience there to feel like an
        afterthought. We didn’t want our designs to be compromised to fit with smaller screens either.</p>
    <p>In this case our designs were sympathetic to being proportionally scaled up and down, so we looked at the
        relationship between different screen sizes to get scaling ratios:</p>
    <img src="https://miro.medium.com/max/1400/1*GzOYNQg-YmBExV_6o_kihg.png">
    <p>Then we rounded out the ratio values so we could keep whole numbers as we scaled:</p>
    <img src="https://miro.medium.com/max/1400/1*UnBgpVjRk01Gbapzh9Vxng.png">
    <p>We baked these rules into how the React codebase calculated sizes (along with typical layout constraints).
    <p>Because our templates were designed with this system in mind, when we tested the final build on tablets and
        smaller
        phones, things looked great right out of the box without needing extra adjustments.</p>
    <p>In our Figma designs we were able to have just one template design for each screen, and use a mixture of the
        scale
        tool and frame resizing to get a preview of how things would look on different devices.</p>
    <div>
        <figure>
            <img src="https://miro.medium.com/max/1400/1*ExxKlGR1Pl3dEzd9xocIJA.png">
            <figcaption>Controls layouts with constraints and scaling rules applied.</figcaption>
        </figure>
    </div>
    <p>There were other responsive design challenges to solve. The app had hundreds of videos and animations, we didn’t
        want
        to have to double handle multiple versions of the content files for different screen dimensions.</p>
    <p>We created all our video / animation content to work in 4:3 but with safe areas that could be cropped for 16:9
        screens.</p>
</section>
<section>
    <h2>Text Sizes & Internationalization</h2>
    <p>With a ‘magic number’, sometimes there will need to be exceptions — with text in particular at smaller sizes a
        few
        pixels makes a lot of difference. But where 8’s didn’t fit, we tried to fall back to 4’s — so some text sizes
        were
        12 & 20px.</p>
    <p>As well as needing variations for smaller copy, we were translating the app for 6 languages. Ideal text sizes
        were
        set in the templates for headings etc, but if a (German!) word didn’t fit within the available space, we created
        code to scale it down to the next heading size that would fit.</p>
    <img src="https://miro.medium.com/max/1400/1*-8FrkflE7egP4wnkCtIilg.png">
    <p>So we ended up with a larger number of heading sizes than we used in the primary designs, but we kept a smooth
        transition of sizes when dropping from H1 to H6.</p>
</section>
<section>
    <h2>Summary</h2>
    <p>Most of our layouts are reasonably simple — centered elements, or 2–3 columns of content. We were lucky not to
        need
        responsive patterns besides the scaling system and basic layout constraints.</p>
    <p>The ‘magic number’ helps the design feel tight, it saves time when deciding how to position, size and space
        things,
        and of course it is much easier to code up a design that follows well defined consistent rules.</p>
    <p>Next step was to figure out the <a
            href="https://blog.prototypr.io/creating-themed-versions-of-a-master-design-in-figma-3d6679ffdeb7">workflow
        for
        our themes.</a></p>
    <p>This post is part of a series <a
            href="https://blog.prototypr.io/building-a-design-system-with-figma-at-littlebits-17edff8f4236">Building a
        Design System with Figma at littleBits</a>. Read the next post <a
            href="https://blog.prototypr.io/creating-themed-versions-of-a-master-design-in-figma-3d6679ffdeb7">Themed
        Versions of a Master Design in Figma</a>.</p>
</section>
</body>
</html>